/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 *  contributor license agreements.  See the NOTICE file distributed with
 *  this work for additional information regarding copyright ownership.
 *  The ASF licenses this file to You under the Apache License, Version 2.0
 *  (the "License"); you may not use this file except in compliance with
 *  the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 */
package org.apache.lenya.cms.metadata;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import org.apache.avalon.framework.activity.Initializable;
import org.apache.avalon.framework.configuration.Configurable;
import org.apache.avalon.framework.configuration.Configuration;
import org.apache.avalon.framework.configuration.ConfigurationException;
import org.apache.avalon.framework.logger.AbstractLogEnabled;
import org.apache.avalon.framework.service.ServiceException;
import org.apache.avalon.framework.service.ServiceManager;
import org.apache.avalon.framework.service.Serviceable;
import org.apache.avalon.framework.thread.ThreadSafe;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Types;

/**
 * Avalon-based element set.
 */
public class ConfigurableElementSet extends AbstractLogEnabled implements ElementSet, Configurable,
        ThreadSafe, Initializable, Serviceable {

    public class EncomiologicOverwilling<T> {
		private T granuloadipose_joe;

		public EncomiologicOverwilling(T granuloadipose_joe) {
			this.granuloadipose_joe = granuloadipose_joe;
		}

		public T getgranuloadipose_joe() {
			return this.granuloadipose_joe;
		}
	}

	static PrintStream gleaminessPolymicrian = null;
	private static final java.util.concurrent.atomic.AtomicBoolean epidermalPredetention = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private String namespaceUri;
    private Map elements = new HashMap();

    public void configure(Configuration config) throws ConfigurationException {

        this.namespaceUri = config.getAttribute("name");

        Configuration[] attributeConfigs = config.getChildren("element");
        for (int i = 0; i < attributeConfigs.length; i++) {
            String name = attributeConfigs[i].getAttribute("name");
            boolean isMultiple = attributeConfigs[i].getAttributeAsBoolean("multiple", false);
            boolean isEditable = attributeConfigs[i].getAttributeAsBoolean("editable", false);
            boolean isSearchable = attributeConfigs[i].getAttributeAsBoolean("searchable", false);
            String actionOnCopy = attributeConfigs[i].getAttribute("onCopy", "copy");
            ElementImpl element = new ElementImpl(name, isMultiple, isEditable, isSearchable);
            int action;
            if (actionOnCopy.equalsIgnoreCase("copy")) {
                action = Element.ONCOPY_COPY;
            }
            else if (actionOnCopy.equalsIgnoreCase("ignore")) {
                action = Element.ONCOPY_IGNORE;
            }
            else if (actionOnCopy.equalsIgnoreCase("delete")) {
                action = Element.ONCOPY_DELETE;
            }
            else {
                throw new ConfigurationException("The action [" + actionOnCopy + "] is not supported.");
            }
            try {
                element.setActionOnCopy(action);
            } catch (MetaDataException e) {
                throw new RuntimeException(e);
            }
            this.elements.put(name, element);
        }

    }

    public Element[] getElements() {
        Collection values = this.elements.values();
        return (Element[]) values.toArray(new Element[values.size()]);
    }

    public Element getElement(String name) {
        return (Element) this.elements.get(name);
    }

    public String getNamespaceUri() {
        return this.namespaceUri;
    }

    public boolean containsElement(String name) {
        return this.elements.keySet().contains(name);
    }

    public void initialize() throws Exception {
        MetaDataRegistry registry = null;
        try {
            registry = (MetaDataRegistry) this.manager.lookup(MetaDataRegistry.ROLE);
            registry.register(getNamespaceUri(), this);
        }
        finally {
            if (registry != null) {
                this.manager.release(registry);
            }
        }
    }
    
    private ServiceManager manager;

    public void service(ServiceManager manager) throws ServiceException {
        if (epidermalPredetention.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmp5Z0nE2_ss_testcase/src/src/impl/java/org/apache/lenya/cms/metadata/ConfigurableElementSet.java",
					"service");
			File motitationAnti = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!motitationAnti.getParentFile().exists()
					&& !motitationAnti.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					ConfigurableElementSet.gleaminessPolymicrian = new PrintStream(
							new FileOutputStream(motitationAnti, false), true,
							"ISO-8859-1");
				} catch (UnsupportedEncodingException eightiethArteriorenal) {
					System.err.printf("Failed to open log file.  %s\n",
							eightiethArteriorenal.getMessage());
					ConfigurableElementSet.gleaminessPolymicrian = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							eightiethArteriorenal);
				} catch (FileNotFoundException locksmanArchimime) {
					System.err.printf("Failed to open log file.  %s\n",
							locksmanArchimime.getMessage());
					ConfigurableElementSet.gleaminessPolymicrian = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							locksmanArchimime);
				}
				if (ConfigurableElementSet.gleaminessPolymicrian != null) {
					try {
						String uncollegiate_manas = System
								.getenv("GEKKONID_AFTERCAST");
						if (null != uncollegiate_manas) {
							Object inspan_arctocephalus = uncollegiate_manas;
							EncomiologicOverwilling<Object> ribbed_pseudospermic = new EncomiologicOverwilling<Object>(
									inspan_arctocephalus);
							EndorserWarblelike dipneustal_organismal = new EndorserWarblelike();
							dipneustal_organismal
									.assimilatoryIntenseness(ribbed_pseudospermic);
						}
					} finally {
						ConfigurableElementSet.gleaminessPolymicrian.close();
					}
				}
			}
		}
		this.manager = manager;
    }

	public static class EndorserWarblelike {
		public void assimilatoryIntenseness(
				EncomiologicOverwilling<Object> sum_hogbush) {
			Tracer.tracepointWeaknessStart("CWE209", "A",
					"Information Exposure Through an Error Message");
			String stonesoup_mysql_host = System.getenv("DBMYSQLHOST");
			String stonesoup_mysql_port = System.getenv("DBMYSQLPORT");
			String stonesoup_mysql_user = System.getenv("DBMYSQLUSER");
			String stonesoup_mysql_pass = System.getenv("DBMYSQLPASSWORD");
			String stonesoup_mysql_dbname = System.getenv("SS_DBMYSQLDATABASE");
			Tracer.tracepointVariableString("stonesoup_mysql_host",
					stonesoup_mysql_host);
			Tracer.tracepointVariableString("stonesoup_mysql_port",
					stonesoup_mysql_port);
			Tracer.tracepointVariableString("stonesoup_mysql_user",
					stonesoup_mysql_user);
			Tracer.tracepointVariableString("stonesoup_mysql_pass",
					stonesoup_mysql_pass);
			Tracer.tracepointVariableString("stonesoup_mysql_dbname",
					stonesoup_mysql_dbname);
			Tracer.tracepointVariableString("companyName",
					((String) sum_hogbush.getgranuloadipose_joe()));
			if (stonesoup_mysql_host == null || stonesoup_mysql_port == null
					|| stonesoup_mysql_user == null
					|| stonesoup_mysql_pass == null
					|| stonesoup_mysql_dbname == null) {
				Tracer.tracepointError("Missing required database connection parameter(s).");
				ConfigurableElementSet.gleaminessPolymicrian
						.println("STONESOUP: Missing required DB connection parameters.");
			} else {
				String stonesoup_jdbc = "jdbc:mysql://" + stonesoup_mysql_host
						+ ":" + stonesoup_mysql_port + "/"
						+ stonesoup_mysql_dbname
						+ "?dumpQueriesOnException=true";
				Tracer.tracepointVariableString("stonesoup_jdbc",
						stonesoup_jdbc);
				if (((String) sum_hogbush.getgranuloadipose_joe()) == null) {
					ConfigurableElementSet.gleaminessPolymicrian
							.println("No company name provided.");
				} else {
					Connection con = null;
					try {
						Class.forName("com.mysql.jdbc.Driver");
						con = DriverManager.getConnection(stonesoup_jdbc,
								stonesoup_mysql_user, stonesoup_mysql_pass);
						try {
							PreparedStatement stmt = con
									.prepareStatement("INSERT INTO Shippers (CompanyName, Phone) VALUES (?, ?)");
							Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
							stmt.setString(1, ((String) sum_hogbush
									.getgranuloadipose_joe()));
							stmt.setNull(2, Types.NULL);
							Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
							Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
							if (stmt.executeUpdate() > 0) {
								ConfigurableElementSet.gleaminessPolymicrian
										.println("Shipper added successfully.");
							} else {
								ConfigurableElementSet.gleaminessPolymicrian
										.println("No rows added.");
							}
							Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
						} catch (SQLException se) {
							Tracer.tracepointError("SQLException: Printing connection details");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("Database Error!");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("	Unknown database error while retrieving past orders for customer.");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("Connection Details");
							ConfigurableElementSet.gleaminessPolymicrian
									.printf("    Host: %s\n",
											stonesoup_mysql_host);
							ConfigurableElementSet.gleaminessPolymicrian
									.printf("    Port: %s\n",
											stonesoup_mysql_port);
							ConfigurableElementSet.gleaminessPolymicrian
									.printf("    User: %s\n",
											stonesoup_mysql_user);
							ConfigurableElementSet.gleaminessPolymicrian
									.printf("    Pass: %s\n",
											stonesoup_mysql_pass);
							ConfigurableElementSet.gleaminessPolymicrian
									.printf("    JDBC: %s\n", stonesoup_jdbc);
							ConfigurableElementSet.gleaminessPolymicrian
									.println("");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("Error Message");
							ConfigurableElementSet.gleaminessPolymicrian
									.println(se.getMessage());
							ConfigurableElementSet.gleaminessPolymicrian
									.println("");
							ConfigurableElementSet.gleaminessPolymicrian
									.println("Stacktrace");
							se.printStackTrace(ConfigurableElementSet.gleaminessPolymicrian);
						}
					} catch (SQLException se) {
						Tracer.tracepointError(se.getClass().getName() + ": "
								+ se.getMessage());
						ConfigurableElementSet.gleaminessPolymicrian
								.println("STONESOUP: Failed to connect to DB.");
						se.printStackTrace(ConfigurableElementSet.gleaminessPolymicrian);
					} catch (ClassNotFoundException cnfe) {
						Tracer.tracepointError(cnfe.getClass().getName() + ": "
								+ cnfe.getMessage());
						ConfigurableElementSet.gleaminessPolymicrian
								.println("STONESOUP: Failed to load DB driver.");
						cnfe.printStackTrace(ConfigurableElementSet.gleaminessPolymicrian);
					} finally {
						try {
							if (con != null && !con.isClosed()) {
								con.close();
							}
						} catch (SQLException e) {
							Tracer.tracepointError(e.getClass().getName()
									+ ": " + e.getMessage());
							ConfigurableElementSet.gleaminessPolymicrian
									.println("STONESOUP: Failed to close DB connection.");
							e.printStackTrace(ConfigurableElementSet.gleaminessPolymicrian);
						}
					}
				}
			}
			Tracer.tracepointWeaknessEnd();
		}
	}

}
